﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;

namespace Collision
{
    /// <summary>
    /// Basisklasse für Kugeln und Wände
    /// </summary>
    abstract class StrokeObject : IDisposable
    {
        /// <summary>Aktuelle Position</summary>
        public Vector Location;

        /// <summary>Aktuelle Geschwindigkeit</summary>
        public Vector Speed;

        /// <summary>Position vor dem Stoß</summary>
        public Vector LastLocation;
        /// <summary>Geschwindigkeit vor dem Stoß</summary>
        public Vector LastSpeed;

        /// <summary>Ablauf-Kennung der Bearbeitung vom Stoß</summary>
        public int StepIndex;

        internal virtual void Draw(Graphics graphics)
        {
            // Wall hat hier nix zu tun
        }

        internal virtual void Step(float duration)
        {
            // Wall hat hier nix zu tun
        }

        #region Dispose

        protected virtual void Dispose(bool disposing)
        {
        }
        public void Dispose()
        {
            this.Dispose(true);
            GC.SuppressFinalize(this);
        }

        #endregion Dispose
    }
}
